<?php
// v 1.55
defined( '_JEXEC' ) or die( 'Restricted access' );
jimport('joomla.plugin.plugin');
jimport('joomla.version');
require_once 'functions.php';

class plgContentSubscribermagnet extends JPlugin
{
    private static $_is_loaded = false;

    private  $_abs_assets, $_url_assets, $_assets; // assets folder
    
    private $_context;
    private $_article; 
    
	public function __construct(& $subject, $config){
		parent::__construct($subject, $config);
        $this->_set_assets();
        $this->_for_admin();
                
	}
    
    // for >= j1.6
    function onContentPrepare($context, &$row, &$params, $page=0){
        if(self::$_is_loaded) return; 
           self::$_is_loaded = true;
           
        $this->_context = str_replace('com_content.', '', $context);
        $this->_article = & $row;
     
        $this->_onOn();
    }
    
    private function _onOn(){
        
        if(!$this->isTargetPage()) return;
       
        $url = JURI::base() . 'plugins/' . $this->_type . '/' . $this->_name; 
        JFactory::getDocument()->addScript($url);
        return true;
    }  
       
    
   /**
     * @since 1.5
     * Открываемая страница относится к секретным?
    */
    public function isTargetPage(){
         // check category
         $categorys = $this->params->get('categorys');
         if(!empty($categorys)){
             if(!is_array($categorys)) $categorys = array($categorys); // for joomla 1.5
             if($this->_context == 'article' && in_array($this->_article->catid, $categorys)) return true;
         }
        
        
         // check menu
         $menuitems = $this->params->get('menuitems');
         if(!empty($menuitems)){
             if(!is_array($menuitems)) $menuitems = array($menuitems); // for joomla 1.5
             
             $menu    = &JSite::getMenu();
             $current = $menu->getActive();
             
             if(in_array($current->id, $menuitems)) return true;
         }
         
         // check custom page
         $pages = $this->params->get('pages');
         if(empty($pages)) return false;
         
         $pages = explode("\n", $pages);
         
         $ids = $uris = array();
         foreach($pages as $v){
            $v = trim($v);
            if(is_numeric($v)){
                $ids[] = $v;
            }
            elseif(strlen($v) >= 5){
                $uris[] = $v;
            }
         }
         // check ids
         if($ids && $this->_context == 'article' && in_array($this->_article->id, $ids)) return true; 
         
         // check uri
         
         if(!$uris) return false; 
         
         foreach($uris as $find){
            $firstSymbol = substr($find, 0, 1);
            if($firstSymbol == '^'){
                $find = substr($find, 1); 
            } 
            else{
                $firstSymbol = '';
            }
            $lastSymbol = substr($find, -1); 
            if($lastSymbol == '$'){
                $find = str_replace('$','',$find);
            }     
            else{
                $lastSymbol = '';
            }   
            
            // ищем вхождение в любом месте        
            if(!$lastSymbol && !$firstSymbol){
                if(stripos($_SERVER['REQUEST_URI'], $find) !== false) return true;
            } 
            else{
                // ищем вхождение в начале/конце строки
                $reg = '/'. $firstSymbol . preg_quote($find, '/') . $lastSymbol . '/ui';
                if(preg_match($reg, $_SERVER['REQUEST_URI'])  > 0 ) return true;
            }
         }
        
         return false;       
    }    
    

    /**
     * @since 1.5
    */
    protected function _set_assets(){
        $assets = SubMagnetFunctions::get_assets($this->_type, $this->_name);
        
        $this->_abs_assets = JPATH_BASE . '/' .$assets;
        $this->_url_assets = JURI::base() . $assets;
        $this->_assets = $assets;
    }
    
    
    /**
     * @since 1.5
    */
    private function _for_admin(){
        
        $mainframe= &JFactory::getApplication();
        if(!$mainframe->isAdmin()){
            return false;
        }        
        
        $adm_assets = str_replace('assets', 'assets_adm', $this->_assets);
        
        $AfterUrl = JURI::root() . 'plugins/content/subscribermagnet/?' . $this->params->get('signal_key');
        
        $js  =  JURI::root() . $adm_assets . 'js.js';
        $ip  =  SubMagnetFunctions::getClientIp();

        $document =& JFactory::getDocument();
        $document->addScript($js);
        
        $document->addScriptDeclaration("SubMagnet.myIP = '{$ip['ip']}'; SubMagnet.AfterUrl = '$AfterUrl';");
    }    
    

}
