<?php
/**
 * @package SubsсriberMagnet
*/
/*
Plugin Name: SubsсriberMagnet
Plugin URI: http://1popov.ru/disc43/
Description: Магнит для подписчика, WP-версия. Плагин позволяет легко закрывать страницы выбранных разделов от НеПодписчиков. Плагин работает с сервисами <a target="_blank" href="http://r.1popov.ru/1323022510">SmartResponder.ru</a> и <a target="_blank" href="http://www.justclick.ru/?p78428">JustClick.ru</a>
Version: 1.57
Author: Evgenix
License: Commercial
*/

if(!function_exists('add_action')) exit();

define('SECRETPAGE_PLUGIN_ASSETS_URL', plugins_url('subscribermagnet')  . '/assets/');
define('SECRETPAGE_PLUGIN_ASSETS_ADM_URL', plugins_url('subscribermagnet')  . '/assets_adm/');
define('SECRETPAGE_PLUGIN_ASSETS_ABS', dirname(__FILE__)  . '/assets/');
define('SECRETPAGE_PLUGIN_NAME', 'Магнит для подписчика');

require_once  'secretpage.plg.class.php';

// ADMIN 
register_activation_hook( __FILE__, array('plgSecretpage','install'));
register_deactivation_hook( __FILE__, array('plgSecretpage','uninstall'));
add_action('admin_menu', 'secretpage_admin_menu');
add_action('admin_init', 'secretpage_admin_init');



// add script for admin 
function secretpage_admin_init() {
    wp_register_script('secretpage_admin_js', SECRETPAGE_PLUGIN_ASSETS_ADM_URL . 'js.js');
    wp_register_style('secretpage_admin_style', SECRETPAGE_PLUGIN_ASSETS_ADM_URL . 'css.css');
    wp_enqueue_script('secretpage_admin_js');
    wp_enqueue_style('secretpage_admin_style');

    wp_enqueue_script("jquery-ui-draggable", array('jquery'));
}

function secretpage_admin_menu(){
    add_options_page(SECRETPAGE_PLUGIN_NAME, SECRETPAGE_PLUGIN_NAME, 8, 'SecretPages', 'secretpage_options_page');
}

function secretpage_options_page(){
	echo '<h1>Настройка плагина <i>&laquo;'.SECRETPAGE_PLUGIN_NAME.'&raquo;</i></h1>';
    if($_POST['secretpage_settings_submit']){
        _secretpage_settings_handlerform();
    }   
    _secretpage_settings_printform();
}

function _secretpage_settings_printform(){
    require_once dirname(__FILE__) . '/form.php';
}

function _secretpage_settings_handlerform(){
    if (function_exists('current_user_can') && !current_user_can('manage_options')) exit();
    if (function_exists ('check_admin_referer') ){
    	check_admin_referer('secretpage_settings_form');
    }   
     
    extract($_POST);
    $errors = array();
    $styles = _secretpage_get_styles(true);
    if(!in_array($style, $styles)){
        echo _secretpage_message('Передано неверное имя стиля');
        return;    
    }
    plgSecretpage::set('style', $style);
    
    $secret_key = trim($secret_key);
    $secret_key = preg_replace('/[^a-z0-9]+/','', $secret_key);
    
    plgSecretpage::set('secret_key', $secret_key);    
    
    $close_url = trim($close_url);
    if(!$close_url) $close_url = get_option('siteurl');    
    plgSecretpage::set('close_url', $close_url);
    
    plgSecretpage::set('title', $title);
    plgSecretpage::set('description', $description);
    plgSecretpage::set('description2', $description2);
    plgSecretpage::set('titleSubcribeMe', $titleSubcribeMe);
    $wmode = ($wmode == 'iframe') ? 'iframe' : 'normal';
    plgSecretpage::set('wmode', $wmode);
    
    
    plgSecretpage::set('smart_api_service', $smart_api_service);
    plgSecretpage::set('smart_api_id', $smart_api_id);
    plgSecretpage::set('smart_api_pass', $smart_api_pass);
    plgSecretpage::set('smart_api_delivery_id', $smart_api_delivery_id);
    plgSecretpage::set('smart_api_recoveryTemplate', $smart_api_recoveryTemplate);    
    
    plgSecretpage::set('run_ips', $run_ips);
    
    // pages
    if($pages){
        $pages = explode(',', $pages);
        $_pages = array();
        
        foreach($pages as $page){
            $page = intval($page);
            if($page){
                $_pages[$page] = $page;
            }
        }
        $pages = ($_pages) ? implode(',', $_pages) : '';
    }
    else{
        $pages = '';
    }
    
    plgSecretpage::set('pages',$pages);
    
    
    // categorys
    $caregorys = array();
    if($categorys){
        foreach($categorys as $_cat){
            $caregorys[] = $_cat;
        }
    }
    plgSecretpage::set('categorys',$caregorys);
    
    echo _secretpage_message('Настройки плагина обновлены', 'updated');
}

function _secretpage_get_styles($returnArray = false){
    $current = plgSecretpage::get('style');
    $styles = array();
    
    foreach(new DirectoryIterator(SECRETPAGE_PLUGIN_ASSETS_ABS . 'styles/') as $dir){
        if($dir->isDot()) continue;
        if($dir->isDir()) $styles[] = $dir->getBasename();
    }
    
    if($returnArray) return $styles;
    
    // html
    $out = '';
    if($styles){
       foreach($styles as $style){
          $selected = ($style == $current) ? 'selected=""' : '';
          $out .= "<option $selected value='$style'>$style</option>";
       }         
    }
    
    return $out;
}

// TODO: 
function _secretpage_get_pages(){}

function _secretpage_get_categorys($returnArray = false){
    // все категории
    $all  = get_categories(array(
        'hide_empty' => false
    ));
    foreach($all as &$cat){
        $cat = (array) $cat;
    }
    
    if($returnArray) return $all;
    
    $arr = array();
    foreach($all as $cat1){
        $arr[$cat1['cat_ID']] = $cat1;
        
    }
    $arr = _secretpage_categorys_array_to_tree($arr);
    return _secretpage_categorys_out($arr);
}

function _secretpage_categorys_out($categorys, $level = 0){
    // текущие выбранные категории
    $current = plgSecretpage::get('categorys');

    $out = ''; // select options
    foreach($categorys as $category){
        $selected = ($current && in_array($category['cat_ID'], $current)) ? 'selected=""' : '';
        $tire = str_repeat('&mdash;', $level);
        $out .= "<option data-level='$level' $selected value='$category[cat_ID]'>$tire $category[name]</option>";
        if($category['childs']){
            $nextLevel = $level + 1;
            $out .= _secretpage_categorys_out($category['childs'], $nextLevel);
        }
        else{
            
        }
    }
    return $out;
}

// построение дерева категорий
function _secretpage_categorys_array_to_tree($dataset) { 
    if(!count($dataset)) return false;
    $tree = array();
    foreach ($dataset as $id=>&$node) 
    {
       if (!$node['parent']) 
       { // root node
         $tree[$id] = &$node;
       } 
       else 
       { // sub node
         $dataset[$node['parent']]['childs'][$id] = &$node;
       }
    }
    return $tree;
}

function _secretpage_message($message, $type = 'error'){
    return '<div id="message" class="'.$type.'"><p>'.$message.'</p></div>';
}



// frn
add_action('init', array('plgSecretpage', 'wpinit'),1);
add_action('wp_head', array('plgSecretpage', 'head'),1);
add_action('wp_footer', array('plgSecretpage', 'footer'),1);


// legacy
if(!function_exists('home_url')){
    function home_url(){
        return get_bloginfo('url');
    }
}

function sm_admin_url_post_type_page(){
    $version = get_bloginfo('version');
    $version = floatval($version);
    
    return ($version < 3) ? admin_url('edit-pages.php') : admin_url('edit.php?post_type=page');
}