<?php
/**
 * SubscriberMagnet v 1.5 wp-wrapper 1.5 
*/
require_once SECRETPAGE_PLUGIN_ASSETS_ABS . 'cls/cls.php';


class plgSecretpage{
    const VERSION = '1.56wp'
    ; 
    public static $CookieName = 'qTy78SbecReLoc1';
    private static $_optPrefix = 'secretpage_';
    
    private static $_on = false;
    
    private static $_options = array( // options default values
                            /// base
                        	'style' => 'dark', 
                        	'secret_key' => '0000',
                        	'close_url' => '',
                            'wmode'     => 'normal', // normal or iframe
                            /// txt
                        	'title' => 'Этот раздел доступен только для подписчиков', 
                            'description' => 'Каждому подписчику выдается специальный код доступа, с помощью которого можно получить доступ к закрытому разделу.',
                            'description2' => 'Подписка бесплатная и займет у вас не более 1 минуты',
                            'titleSubcribeMe' =>  'Открыть для меня доступ',
                            /// categorys
                            'categorys' => '', 
                            /// SubscribeService
                            'smart_api_service' => 'smartresponder', // service name smartresponder or justclick
                        	'smart_api_id' => '',
                        	'smart_api_pass' => '',
                        	'smart_api_delivery_id' => '',   
                            'smart_api_recoveryTemplate' => '[first_name],&#13;&#10;Ваш код доступа к секретному разделу {{secret_key}}',
                            /// other
                            'request_key'   => 'aQyrTcmWkcpjUpqj89QmksdfR7',
                            'signal_key'    => 'secretpagessuccesssubscribeentercode'
    );     
    
    public static function wpinit(){
       if(!self::_is_enable()) return false;        
       
       // если грузим в iframe-режиме
       if(isset($_GET['wmodeframe']) && $_GET['wmodeframe'] == self::$_options['request_key']) {
           self::_onLoadFrameForm();
       }
                  
       if(stripos($_SERVER['REQUEST_URI'], self::get('signal_key')) !== false){
        
          if($_COOKIE['plgSecretpageReturnPage']){
              $returnPage = $_COOKIE['plgSecretpageReturnPage'];
              
              setcookie('plgSecretpageReturnPage', '', (time() - 6000), '/', $_SERVER['SERVER_NAME']);
              setcookie('plgSecretpageAction', 'enterCode', (time() + 600), '/', $_SERVER['SERVER_NAME']);  
              
              exit(header('Location: '.$returnPage.'/#enterCode'));  
          }
          else self::$_on = true;  
       }
      
       // запуск обработчика формы
       if(isset($_POST[self::$_options['request_key']])){
          self::_formHandler();
       }
    

      
       self::_registerJS();
    }    
    

    
    public static function head(){
       // Ищем закрытые страницы
       if(!self::_is_enable()) return false;  
       if(!self::_findSecretPages()) return false;

       if(self::get('wmode') == 'normal'){ // norm-mode
           echo self::_getPluginCss(); 
       } else{ 
            $url = home_url() . '/?wmodeframe=' . self::$_options['request_key'];    
            $js = file_get_contents(SECRETPAGE_PLUGIN_ASSETS_ABS . 'ifr.tpl'); 
            $js = self::_parseTemplate(array('url' => $url), $js);
            echo $js;
      }      
    }
     
     //    
     public static function footer(){
        if(!self::$_on) return;
        if(self::get('wmode') == 'normal'){ // norm-mode only
               echo self::_getPluginHtml();
        }
     }
     
     public static function getPrefix(){
        return self::$_optPrefix;
     }
     
     public static function install(){
        foreach(self::$_options as $key=>$value){
            $name = self::$_optPrefix . $key;
            add_option($name, $value);
        }
     }
     
     public static function uninstall(){
        $keys = array_keys(self::$_options);
        foreach($keys as $key=>$value){
            $name = self::$_optPrefix . $key;
            delete_option($name);
        }
     }    

     /** Get option 
     */
     public static function get($name){
        
        if($name == 'categorys') return self::_getClosedCategorys($value);
        
        $name = self::$_optPrefix . $name;
        return get_option($name);
     }

     /** Set option 
     */     
     public static function set($name, $value){
        if($name == 'categorys') return self::_setClosedCategorys($value);
        
        $name = self::$_optPrefix . $name;
        update_option($name, $value);
     }
     
     public static function getServices($return = 'select'){
        $arr =  SubsriberMagnetServiceApi::getServices();
 
        if($return == 'list')  return  implode(',',$array);
        $current = self::get('smart_api_service');
        
        if($return == 'current'){
            return ($current) ? $current : '0';
        }
        
        if($return == 'select'){
            $out = '';
            
            if(!$current) {
                $out .= '<option selected="selected" value="0">-- Выбрать сервис --</option>';
            }           
            
            foreach($arr as $item){
                $sel = ($item == $current) ? 'selected="selected"' : '';
                $out .= "<option value='$item' $sel>$item</option>";
            }
            
            return "<select name='smart_api_service'>$out</select>";            
        }
        
        return  $arr;
     }
    
    private static function _findSecretPages(){
       if(!(is_single() || is_page())) return false;
       
       $closedCategorys = plgSecretpage::get('categorys');
       if(!$closedCategorys) return;
        
       $post_id = null ;
       $post = get_post($post_id);
       
       $categorys = array(); 
       
       // Ищем категорию поста в закрытых категориях
       foreach(get_the_category($post->ID) as $cat){
          if(in_array($cat->cat_ID, $closedCategorys)){
            self::$_on = true;
            break;
          }       
       }
       
       // Проверям есть ли в списке одиночных страниц 
       $s = self::_getSelectedPages();
       if(!self::$_on && !empty($s)){
           if(in_array($post->ID, $s)){
               self::$_on = true; 
           } 
       }         
       
       return self::$_on;       
    }    
     
     
    
    private static function _getSelectedPages(){
        $pages = self::get('pages');
        if(!$pages) return false;
        
        $pages = explode(',', $pages);
        return $pages;
    }  

    private static function _registerJS(){
       if(self::get('wmode') != 'normal') return; 
       wp_register_script(
            'plgSecretpage',
            SECRETPAGE_PLUGIN_ASSETS_URL . 'js/js.js',
            array('jquery'),
            self::VERSION,
            false
       ); 
       wp_enqueue_script('plgSecretpage');               
     }
     
     private static function _formHandler()  {
        if($_SERVER['HTTP_X_REQUESTED_WITH'] != 'XMLHttpRequest') return;
        
        
        $service = SubsriberMagnetServiceApi::getService(
            self::get('smart_api_id'), 
            self::get('smart_api_pass'), 
            self::get('smart_api_delivery_id'),
            self::get('smart_api_service')
        );
        
        $service->after_subscribe_url = site_URL().'/?'.self::get('signal_key');
        

        $recoveryTemplate = str_replace('&#13;&#10;', "\n", self::get('smart_api_recoveryTemplate'));
        $recoveryTemplate = str_replace('{{secret_key}}',   self::get('secret_key'), $recoveryTemplate);
        
        $handler = new SubsriberMagnetHandler($service, $_REQUEST, self::$CookieName); 
        $handler->set('recoveryTemplate', $recoveryTemplate);
        $handler->set('secret_key', self::get('secret_key'));
        
        $handler->execute();        
        exit;
     }
      

    /** 
     * @return array ids 
    */
    private static function _getClosedCategorys(){
        return explode(',',get_option(self::$_optPrefix . 'categorys'));
    }
    
    /**
     * @param  array
     * @return str
    */
    private static function _setClosedCategorys($array){
        $caregorys = implode(',', $array);
        update_option(self::$_optPrefix . 'categorys', $caregorys); 
        return $caregorys;
    }   
    
    /**
     * @version 1.5
    */
    private static function _getPluginHtml(){
                 
        $_keys = array_keys(self::$_options);
        foreach($_keys as $key){
             if(strpos($key, 'smart_api') === true) continue;
             $keys[$key] = self::get($key);
        }
        
        $keys['loading_img'] = SECRETPAGE_PLUGIN_ASSETS_URL . 'styles/' . self::get('style') . '/preloader.gif';
        $template = file_get_contents(SECRETPAGE_PLUGIN_ASSETS_ABS . 'template.tpl'); 
        
        $template = self::_parseTemplate($keys, $template);
        $template = self::_compactHtml($template);
  
        return $template;
    } 

    /**
      * @since 1.5
      * Парсим шаблон
    */       
    private static function _parseTemplate($keys, $template){
        foreach($keys as $key=>$v){
             $template = str_replace('{{'.$key.'}}', $v, $template);
        }        
        return $template;
    }
    
    /**
      * @since 1.5
      * Удаляем лишние пробелы в HTML
    */     
    private static function _compactHtml($string){
       $string = preg_replace("/\s+/", ' ', $string);
       $string = str_replace('> <', '><', $string);   
       return $string;     
    }

    /**
      * @since 1.5
      * Загружаем IFRAME-форму
    */     
    private static function _onLoadFrameForm(){
        $wrapper = file_get_contents(SECRETPAGE_PLUGIN_ASSETS_ABS . 'wrapper.tpl');
        // Подключен ли плагин GoodAlert
        $good_alert = get_option('goodalert_style');
        if($good_alert && function_exists('GoodAlert')){
           $good_alert = GoodAlert($good_alert);
        }
        else{
            $good_alert = '';
        }
        $fields = array(
             'title'     => self::get('title') 
            ,'form'     => self::_getPluginHtml()
            ,'style'    => self::_getPluginCss()
            ,'js'       => SECRETPAGE_PLUGIN_ASSETS_URL . '/js/js.js?v=1.51'
            ,'jquery'   => SECRETPAGE_PLUGIN_ASSETS_URL . '/js/jquery.js'
            ,'home'     => home_url()
            ,'goodalert'=> $good_alert
        ); 
        
        $wrapper = self::_parseTemplate($fields, $wrapper);
        
        exit($wrapper);  
    }    
    
    private static function _getPluginCss(){
       $_style = self::get('style');

       $style  = SECRETPAGE_PLUGIN_ASSETS_URL . 'styles/'.$_style.'/css.css';
       $return = '<link rel="stylesheet" href="'. $style .'" />';

       $style   = SECRETPAGE_PLUGIN_ASSETS_URL . 'styles/'.$_style.'/css_ie.css';
       $return .= '<!--[if lt IE 9]><link rel="stylesheet" href="'. $style .'" /><![endif]-->';
       return $return;
         
    }    
    
    /**
     * Разрешен запуск или нет
    */
    private static function _is_enable(){
        if($_COOKIE[self::$CookieName]) return false;
        
        // Если включен только для определенных IP-адресов
        $ips = self::get('run_ips');
        if($ips){
            $ips = explode(',',$ips);
            return (in_array($_SERVER['REMOTE_ADDR'], $ips));
        }
        return true;
    }
}

