<?php
/**
 * @package SubsriberMagnet 1.55
*/
define('SMAGNET_COOKIENAME', 'qTy78SbecReLoc1');
if($_COOKIE[SMAGNET_COOKIENAME]) return; 

define('SMAGNET_ASSETS_PATH', dirname(__FILE__) . '/assets/');
require_once 'secretpage_cfg.php';

SubsriberMagnetCfg::$request_key = SMAGNET_COOKIENAME;

SubsriberMagnetServiceStart();

function SubsriberMagnetServiceStart(){
    $cfg = SubsriberMagnetCfg::in();    
    
    // handler form
    if($_SERVER['HTTP_X_REQUESTED_WITH'] == 'XMLHttpRequest'){
       if(!isset($_POST[$cfg->get('request_key')])) exit(json_encode(array('error' => 'request_key_error')));
       
       // OK. NEXT
       require_once SMAGNET_ASSETS_PATH . 'cls/cls.php';
       
       $service = SubsriberMagnetServiceApi::getService(
            $cfg->get('smart_api_id'), 
            $cfg->get('smart_api_pass'), 
            $cfg->get('smart_api_delivery_id'),
            $cfg->get('smart_api_service')
       );   
       
       // only SmartResponder 
       if($cfg->get('smart_api_recoveryTemplate')){
            $recoveryTemplate = str_replace('&#13;&#10;', "\n", $cfg->get('smart_api_recoveryTemplate'));
            $recoveryTemplate = str_replace('{{secret_key}}',   $cfg->get('secret_key'), $recoveryTemplate);        
       }
       
       $service->after_subscribe_url = $cfg->get('home_url').'/?'.$cfg->get('signal_key'); 
       
       $handler = new SubsriberMagnetHandler($service, $_REQUEST, SMAGNET_COOKIENAME); 
       $handler->set('recoveryTemplate', $recoveryTemplate);
       $handler->set('secret_key', $cfg->get('secret_key'));
        
       $handler->execute();        
       exit; 
    }
    
    // load frame    
    $Form = new SubsriberMagnetForm($cfg);
    if($Form->is_frame_load()){
        echo $Form->onLoadFrameForm();
        exit();
    }
    
    return;    
}